<template>
    <div class="app-mob-treeview <#if appde??>${appde.getCodeName()?lower_case}-${ctrl.name}</#if> <#if ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()> ${singleCss.getCssName()}</#if>">
    <#if ctrl.render??>
    ${ctrl.render.code}
    <#else>
        <div class="treeNav">
            <template v-for="(item,index) in treeNav">
            <ion-label  :key="item.id" class="sc-ion-label-ios-h sc-ion-label-ios-s ios hydrated" :class="index+1 < treeNav.length? 'treeNav-active':'' " @click="nav_click(item)">{{item.text}}</ion-label>
            <span class="tree-span" :key="item.id+'span'" v-if="index+1 < treeNav.length">></span>
            </template>
        </div>
        <div class="tree-partition" v-if="valueNodes.length > 0" ></div>
        <ion-list>
        <template v-for="(item ,index) in rootNodes">
            <ion-item  :key="index" @click="click_node(item)">
                <ion-label>{{item.text}}</ion-label>
                <app-mob-icon class="tree-icon" position="end" name="chevron-forward-outline"></app-mob-icon>
            </ion-item>
        </template>
       </ion-list>
        <div class="tree-partition tree-partition-bigger" v-if="rootNodes.length > 0"></div>
        <!-- 树视图 -->
        <ion-list v-if="viewType == 'DEMOBTREEVIEW'">
        <template v-for="item in valueNodes">
            <ion-item :key="item.srfkey">
                <ion-label>{{item.text}}</ion-label>
            </ion-item>
        </template>
       </ion-list>
       <!-- 树多选 -->
        <ion-list v-else-if="viewType == 'DEMOBPICKUPTREEVIEW' && !isSingleSelect">
        <template v-for="item in valueNodes">
            <ion-item :key="item.srfkey">
                <ion-checkbox color="secondary" v-if="viewType == 'DEMOBPICKUPTREEVIEW' && !isSingleSelect" :ref="item.srfkey+'checkbox'"  :checked="item.selected" :value="item.srfkey" slot="end" @ionChange="onChecked"></ion-checkbox>
                <ion-label class="tree_item_label">
                    <template v-if="item.strIcon != 'default_text'">
                        <img class="tree_item_img" v-if="item.strIcon" :src="item.strIcon" />
                        <div v-else class="tree_item_index_text">{{item.text.substring(0,1)}}</div>
                    </template>
                    {{item.text}}
                </ion-label>
            </ion-item>
        </template>
       </ion-list>
       <!-- 树单选 -->
        <ion-radio-group v-else-if="viewType == 'DEMOBPICKUPTREEVIEW' && isSingleSelect" :value="selectedValue" >
            <template v-for="item in valueNodes">
                <ion-item  :key="item.srfkey"   @click="onSimpleSelChange(item)">
                    <ion-label class="tree_item_label">
                        <template v-if="item.strIcon != 'default_text'">
                            <img class="tree_item_img" v-if="item.strIcon" :src="item.strIcon" />
                            <div v-else class="tree_item_index_text">{{item.text.substring(0,1)}}</div>
                        </template>
                        {{item.text}}
                    </ion-label>
                    <ion-radio slot="end" :checked="item.selected" :value="item.srfkey"></ion-radio>
                </ion-item>
            </template>
        </ion-radio-group>
    </#if>
        <app-mob-context-menu ref="contextmenu">
         <div slot="content" >
            <#if ctrl.getPSControls()??>
            <#list ctrl.getPSControls() as childCtrl>
            <#if childCtrl.getControlType() == "CONTEXTMENU">
            <div v-if="activeNode == '${childCtrl.getOwner().getNodeType()}'">
                <@ibizindent blank=16>
                    ${P.getCtrlCode(childCtrl,'CONTROL.html').code}
                </@ibizindent>
            </div>
            </#if>
            </#list>
            </#if>
        </div>
        </app-mob-context-menu>
    </div>
</template>