<#ibizinclude>
./CONTROL-BASE.template.ftl
</#ibizinclude>

<#ibizinclude>
../../@NAVPARAMS/FUNC/PUBLIC.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 视图类型
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected viewType?: string | 'DEMOBMDVIEW' | 'DEMOBMDVIEW9' | 'DEMOBWFMDVIEW';

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop({ default: true }) protected showBusyIndicator?: boolean;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected updateAction!: string;
    
    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected fetchAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected removeAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected loadAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected loaddraftAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() protected createAction!: string;

    /**
     * 部件样式
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop({default: '<#if ctrl.getMobListStyle?? && ctrl.getMobListStyle()??>${ctrl.getMobListStyle()}</#if>'}) protected controlStyle!: string | 'ICONVIEW'  | 'LISTVIEW' | 'SWIPERVIEW' | 'LISTVIEW2' | 'LISTVIEW3' | 'LISTVIEW4';

    /**
    * 上级传递的选中项
    * @type {Array}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     @Prop() public selectedData?:Array<any>;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop({default: true}) protected needLoadMore?: boolean;

    /**
    * 新建打开视图
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public newdata?: Function; 


    /**
    * 打开视图
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public opendata?: Function; 

    /**
    * 加载显示状态
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public loadStatus: boolean = false;

    /**
    * 关闭行为
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public close?:Function;

    /**
    * 是否显示加载文字
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop({ default: true}) public isNeedLoaddingText?:boolean;

    /**
    * 是否为临时模式
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop({ default: false}) public isTempMode?:boolean;

    /**
    * 存放多数据选择数组（多选）
    *
    * @type {array}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public checkboxList:Array<string> = [];

    /**
    * 是否为分组模式
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public isEnableGroup:boolean = <#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()??> ${ctrl.isEnableGroup()?c}<#else>false</#if>;

    /**
    * 代码表分组细节
    *
    * @type {Object}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public group_detail:any = <#if ctrl.getGroupPSCodeList?? && ctrl.getGroupPSCodeList()?? && ctrl.getGroupPSCodeList().getAllPSCodeItems?? && ctrl.getGroupPSCodeList().getAllPSCodeItems()??> <#assign codelist = ctrl.getGroupPSCodeList().getAllPSCodeItems()> [<#list codelist as item> <#if item.getValue?? && item.getValue()?? && item.getName?? && item.getName()??>{"value":'${item.getValue()}',"text":'${item.getName()}'},</#if></#list>]<#else>[]</#if>;

    /**
    * 分组模式
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public group_mode = <#if ctrl.getGroupMode?? && ctrl.getGroupMode()??>'${ctrl.getGroupMode()}'<#else>''</#if>;

    /**
    * 分组数据
    *
    * @type {array}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public group_data?:any = [];

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public appStateEvent: Subscription | undefined;

    /**
    * 分组标识
    *
    * @type {array}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public group_field:string = <#if ctrl.getGroupPSDEField?? && ctrl.getGroupPSDEField()?? && ctrl.getGroupPSDEField().getCodeName?? && ctrl.getGroupPSDEField().getCodeName()??>'${ctrl.getGroupPSDEField().getCodeName()?lower_case}'<#else>''</#if>;

    /**
     * 分组方法
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public group(){
      let _this:any = this;
      if(_this.getGroupDataByCodeList && _this.getGroupDataByCodeList instanceof Function && Object.is(_this.group_mode,"CODELIST") ){
        _this.getGroupDataByCodeList(_this.items);
      }else if(_this.getGroupDataAuto && _this.getGroupDataAuto instanceof Function && Object.is(_this.group_mode,"AUTO") ){
        _this.getGroupDataAuto(_this.items);
      }
    }

<#if  ctrl.isEnableGroup?? && ctrl.isEnableGroup()?? && ctrl.isEnableGroup()>
    /**
     * vant折叠面板数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public activeName:Array<any> = [];

    /**
     * 只需第一次赋值面板
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public valve:number = 0;

    /**
     * 折叠面板改变时
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public changeCollapse($event:any){
      this.activeName = $event;
    }
</#if>

    /**
    * 存放数据选择数组(单选)
    *
    * @type {object}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public radio:any = '';

    /**
    * 分页大小
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public pageSize: number = ${ctrl.getPagingSize()?c};

    /**
    * 总页数
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public pageTotal: number = 0;

    /**
    * 当前页数
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public pageNumber: number = 1;

    /**
    * 判断底部数据是否全部加载完成，若为真，则 bottomMethod 不会被再次触发
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    get allLoaded() {
        return ((this.pageNumber + 1) * this.pageSize) >= this.pageTotal ? true : false;
    }

    /**
    * searchKey 搜索关键字
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public searchKey:string = '';

    /**
    * 列表数组
    *
    * @param {Array<any>}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public items:Array<any> =[];

    /**
    * 选中数组
    *
    * @param {Array<any>}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectedArray:Array<any> = [];

    /**
    * 多选计数
    *
    * @param {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectednumber:number = 0;

    /**
    * 搜索行为
    *
    * @param {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public searchAction?:string;

    /**
    * 是否为选择视图
    *
    * @param {boolean} 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public isSelected?:boolean;

    /**
    * 是否多选
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop({default:false}) public isMutli?: boolean;

    /**
    * 单选选择值
    *
    * @param {string} 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectedValue:string = ""; 

    /**
    * 部件排序对象
    *
    * @param {object} 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public sort: any = { <#if ctrl.isNoSort?? && ctrl.isNoSort()??><#if ctrl.getMinorSortPSAppDEField?? && ctrl.getMinorSortPSAppDEField()??><#assign sortableField = ctrl.getMinorSortPSAppDEField() /><#if sortableField.getName?? && sortableField.getName()??>sort:'${sortableField.getName()?lower_case},<#if ctrl.getMinorSortDir?? && ctrl.getMinorSortDir()??>${ctrl.getMinorSortDir()?lower_case}</#if>'</#if></#if></#if>};
    

    /**
     * 上拉加载更多数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public async loadBottom(): Promise<any> {
        if (this.allLoaded) {
          return;
        }
        this.pageNumber++;
        let params = {};
        if (this.viewparams) {
            Object.assign(params, this.viewparams);
        }
        Object.assign(params, { query: this.searchKey, page: this.pageNumber, size: this.pageSize });
        let response: any = await this.load(params, 'bottom',false);
        let loadmoreBottom: any = this.$refs.loadmoreBottom;
        if (loadmoreBottom) {
            loadmoreBottom.complete();
        }
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public async remove(datas: any[]): Promise<any> {
        let arg: any = {};
        let keys: Array<string> = [];
        let infoStr: string = '';
        datas.forEach((data: any, index: number) => {
            keys.push(data.${appde.getKeyPSAppDEField().getCodeName()?lower_case});
            if (index < 5) {
                if (!Object.is(infoStr, '')) {
                    infoStr += '、';
                }
                <#if appde.getMajorPSAppDEField()??>
                infoStr += data.${appde.getMajorPSAppDEField().getCodeName()?lower_case};
                <#else>
                infoStr += data.srfmajortext;
                </#if>
            }
        });
        if(datas.length <= 0 ){
          this.$notice.error('请选择至少一条删除~')
          return
        }
        if (datas.length < 5) {
            infoStr = infoStr + this.$t('app.message.totle') + datas.length + this.$t('app.message.data');
        } else {
            infoStr = infoStr + '...' + this.$t('app.message.totle') + datas.length + this.$t('app.message.data');
        }
        return new Promise((resolve, reject) => {
            const _remove = async () => {
                let _context: any = { ${appde.getCodeName()?lower_case}: keys.join(';') }
                const response: any = await this.service.delete(this.removeAction, Object.assign({}, this.context, _context), arg, this.showBusyIndicator);
                if (response && response.status === 200 && response.data.records) {
                    this.$notice.success((this.$t('app.message.deleteSccess') as string));
                    this.load();
                    resolve(response);
                } else {
                    this.$notice.error(response.message?response.message:"删除失败");
                    reject(response);
                }
            }

            this.$dialog.confirm({
                title: (this.$t('app.message.warning') as string),
                message: this.$t('app.message.confirmToDelete') + infoStr +','+ this.$t('app.message.unrecoverable') + '？',
            }).then(() => {
                _remove();
            }).catch(() => {
            });
        });
    }

    /**
     * 刷新数据
     *
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public refresh(): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            this.load().then((res) => {
                resolve(res);
            }).catch((error: any) => {
                reject(error);
            })
        })
    }

    <#if ctrl.getQuickPSDEToolbar?? && ctrl.getQuickPSDEToolbar()??>
      <#assign quickToolbar = ctrl.getQuickPSDEToolbar()/>
      ${P.getCtrlCode(quickToolbar, 'CONTROL.vue').code}
    </#if>

    /**
     * 长按状态改变事件
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onCheackChange(){
        this.$emit('isChooseChange', !this.isChoose);
    }

    /**
     * 快速搜索
     *
     * @param {string} query
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public async quickSearch(query: string): Promise<any> {
        this.searchKey = query;
        this.pageNumber = 0;
        const response = await this.load(Object.assign({ query: query }, { page: this.pageNumber, size: this.pageSize }), "init");
        return response;
    }

    /**
     * 数据加载
     *
     * @private
     * @param {*} [data={}]
     * @param {string} [type=""]
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private async load(data: any = {}, type: string = "",isloadding = this.showBusyIndicator): Promise<any> {
        if (!data.page) {
            Object.assign(data, { page: this.pageNumber });
        }
        if (!data.size) {
            Object.assign(data, { size: this.pageSize });
        }
        //部件排序
        if(this.sort){
​           Object.assign(data,this.sort);
        }
        //视图排序
        if(data.data && data.data.sort){
            Object.assign(data, { sort:data.data.sort });
        }
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(data, parentdata);
        let tempViewParams:any = parentdata.viewparams?parentdata.viewparams:{};
        Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        Object.assign(data,tempViewParams);
        const response: any = await this.service.search(this.fetchAction, this.context, data, isloadding);
        this.bottomLoadding = false;
        if (!response || response.status !== 200) {
            this.$notify({ type: 'danger', message: response.error.message });
            return response;
        }

        this.$emit('load', (response.data && response.data.records) ? response.data.records : []);
        this.pageTotal = response.data.total;
        this.$emit('pageTotalChange',this.pageTotal);
        if (type == 'top') {
            this.items = [];
            this.items = response.data.records;
        } else if (type == 'bottom') {
            for (let i = 0; i < response.data.records.length; i++) {
                this.items.push(response.data.records[i]);
            }
        } else {
            this.items = [];
            this.items = response.data.records;
        }
        this.items.forEach((item:any)=>{
            // 计算是否选中
            let index = this.selectedArray.findIndex((temp:any)=>{return temp.srfkey == item.srfkey});
            if(index != -1 || Object.is(this.selectedValue,item.srfkey)){
                item.checked = true;
            }else{
                item.checked = false;
            }
            Object.assign(item,this.getActionState(item)); 
            // 计算权限   
            this.setSlidingDisabled(item);
        });
        if(this.isEnableGroup){
          this.group();
        }
        return response;
    }

<#if ctrl.getGroupMode?? && ctrl.getGroupMode()?? && ctrl.getGroupMode() == 'CODELIST'>
    /**
     * 代码表分组，获取分组数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getGroupDataByCodeList(items:any){
      let group:Array<any> = [];
      this.group_detail.forEach((obj:any,index:number)=>{
        let data:any = [];
        items.forEach((item:any,i:number)=>{
          if (item[this.group_field] === obj.value) {
            data.push(item);
          }
        })
        group.push(data);
      })
      group.forEach((arr:any,index:number)=>{
        this.group_data[index] = {};
        this.group_data[index].text = this.group_detail[index].text;
        this.group_data[index].items = arr;
      })
      this.group_data.forEach((item:any,i:number)=>{
        if (item.items.length == 0) {
          this.group_data.splice(i,1);
        }
      })
      // vant 折叠面板
      if (this.valve == 0) {
        this.activeName[0] = this.group_data[0].text;
        this.valve++;
      }
    }
</#if>

<#if ctrl.getGroupMode?? && ctrl.getGroupMode()?? && ctrl.getGroupMode() == 'AUTO'>
    /**
     * 
     * 自动分组，获取分组数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getGroupDataAuto(items:any){
      let groups:Array<any> = [];
      items.forEach((item:any)=>{
        if(item.hasOwnProperty(this.group_field)){
          groups.push(item[this.group_field]);
        }
      })
      groups = [...new Set(groups)];
      groups.forEach((group:any,index:number)=>{
        this.group_data[index] = {};
        this.group_data[index].items = [];
        items.forEach((item:any,i:number)=>{
          if (group == item[this.group_field]) {
            this.group_data[index].text = group;
            this.group_data[index].items.push(item);
          }
        })
      })
    }
</#if>

    /**
     * 下拉刷新
     *
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public async pullDownToRefresh(): Promise<any> {
        this.pageNumber = 0;
        let params = {};
        if (this.viewparams) {
            Object.assign(params, this.viewparams);
        }
        Object.assign(params, { query: this.searchKey, pageNumber: this.pageNumber, pageSize: this.pageSize });
        let response: any = await this.load(params, 'top');
        return response;
    }

    /**
    * 点击回调事件
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public item_click(item:any){
        if(this.isChoose){
            let count = this.selectedArray.findIndex((i) => {
            return i.mobentityid == item.mobentityid;
        });
            if (count === -1) {
                this.selectedArray.push(item);
            } else {
                this.selectedArray.splice(count, 1);
            }
        } else {
            this.goPage(item)
        }
    }

    /**
    * 点击列表数据跳转
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public goPage(item: any) {
        this.$emit('rowclick',item);
    }

    /**
    * 获取多项数据
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public getDatas(): any[] {
      return this.service.handleRequestDatas(this.context,this.selectedArray);
    }

    /**
    * 获取单项数据
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public getData(): any {
        return this.selectedArray[0];
    }

    /**
    * vue生命周期created
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}
     */    
    protected afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action, "load")) {
                    this.pageNumber = 0;
                    this.load(Object.assign(data, { page: this.pageNumber, size: this.pageSize }), "init");
                }
                if (Object.is(action, "search")) {
                    this.pageNumber = 0;
                    this.load(Object.assign(data, { page: this.pageNumber, size: this.pageSize }), "init");
                }
                if (Object.is(action, "quicksearch")) {
                    this.searchKey = data;
                    this.pageNumber = 0;
                    this.load(Object.assign({ query: data }, { page: this.pageNumber, size: this.pageSize }), "init");
                }
                if (Object.is(action, "refresh")) {
                    this.refresh();
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"${ctrl.getPSAppDataEntity().getCodeName()}")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh();
                }
            })
        }
        <#if view.getViewType()?? && view.getViewType()=='DEMOBPICKUPMDVIEW'>
        if (!this.isMutli) {
            if (this.selectedData && this.selectedData.length > 0) {
                this.radio = this.selectedData[0].srfkey;
            }
        } else {
            if (this.selectedData && this.selectedData.length > 0) {
                this.checkboxList = [];
                this.selectedData.forEach((item: any) => {
                    this.checkboxList.push(item.srfkey);
                })
            }
        }
        </#if>
    }

    /**
     * ion-item-sliding拖动事件
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ionDrag(){
      this.$store.commit('setPopupStatus',false)
    }

    /**
     * 滚动条事件（计算是否到底部）
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public scroll(e:any){
        let list:any = this.$refs.mdctrl;
        if(list){
            let scrollTop = list.scrollTop;
            let clientHeight = list.clientHeight;
            let scrollHeight = list.scrollHeight;
            if(scrollHeight > clientHeight && scrollTop + clientHeight === scrollHeight){
                if(!this.allLoaded){
                    this.bottomLoadding = true;
                    this.loadBottom();
                }
            }
        }
    }

    /**
     * 底部加载状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public bottomLoadding = false;

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public beforeDestroy(){
      let list:any = this.$refs.mdctrl;
      if(list){
        list.removeEventListener('touchend',()=>{
          this.$store.commit('setPopupStatus',true)
        })
      }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
        window.removeEventListener('contextmenu',()=>{});
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 列表项左滑右滑触发行为
     *
     * @param {*} $event 点击鼠标事件
     * @param {*} tag 操作标识
     * @param {*} item 行数据
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public mdctrl_click($event: any, tag: any, item: any): void {
        $event.stopPropagation();
        this.selectedArray = [];
        this.selectedArray.push(item);
<#if ctrl.getPSDEUIActionGroup()?? && ctrl.getPSDEUIActionGroup().getPSUIActionGroupDetails()??>
<#assign details = ctrl.getPSDEUIActionGroup().getPSUIActionGroupDetails()>
<#list details as detail>
        if (Object.is(tag, '${detail.getName()}')) {
            this.mdctrl_${detail.getName()}_click();
        }
</#list>
</#if>
<#if ctrl.getPSDEUIActionGroup2()?? && ctrl.getPSDEUIActionGroup2().getPSUIActionGroupDetails()??>
<#assign details = ctrl.getPSDEUIActionGroup2().getPSUIActionGroupDetails()>
<#list details as detail>
        if (Object.is(tag, '${detail.getName()}')) {
            this.mdctrl_${detail.getName()}_click();
        }
</#list>
</#if>
        this.closeSlidings(item);
    }

    /**
     * 关闭列表项左滑右滑
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public closeSlidings (item: any) {
        const ele :any= this.$refs[item.srfkey];
        if(ele[0] && this.$util.isFunction(ele[0].closeOpened)){
            ele[0].closeOpened();
        }
    }

    /**
     * 单选选中变化
     * 
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public onSimpleSelChange(item: any = {}) {
        this.$emit('selectionchange', [item]);
        this.selectedValue = item.srfkey;
        this.selectedArray = [];
        this.goPage(item);
    }


   /**
     * 是否展示多选
     *
     * @memberof Mdctrl
     */
    @Prop({default:false}) isChoose?: boolean;

    /**
     * 选中或取消事件
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public checkboxSelect(item:any){
        item.checked = !item.checked
        let count = this.selectedArray.findIndex((_item:any) => {
            return _item.${appde.getKeyPSAppDEField().getCodeName()?lower_case} == item.${appde.getKeyPSAppDEField().getCodeName()?lower_case};
        });
        if(count == -1){
            this.selectedArray.push(item);
        }else{
            this.selectedArray.splice(count , 1);
        }
        let _count = Object.is(this.items.length , this.selectedArray.length)? 1 : this.selectedArray.length > 0 ? 2 : 0;
        this.$emit("checkBoxChange", _count)
        this.$forceUpdate();
    }
    /** 
     * checkbox 选中回调
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public checkboxChange(data: any) {
        let { detail } = data;
        if (!detail) {
            return;
        }
        let { value } = detail;
        this.selectednumber = 0;
        this.items.forEach((item: any, index: number) => {
            if (item.value) {
                this.selectednumber++;
            }
            if (Object.is(item.${appde.getKeyPSAppDEField().getCodeName()?lower_case}, value)) {
                if (detail.checked) {
                    this.selectedArray.push(this.items[index]);
                } else {
                    this.selectedArray.splice(this.selectedArray.findIndex((i: any) => i.value === item.value), 1)
                }
            }
        });
        this.$emit('selectionchange', this.selectedArray);
    }

    /**
     * 全选事件
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public checkboxAll(value:any) {
        for (let index = 0; index < this.items.length; index++) {
            const item = this.items[index];
            this.items[index].checked = value;
        }
        if(value){
            this.selectedArray = [...this.items];
        }else{
            this.selectedArray = [];
        }
        this.$forceUpdate();
    }

    <#macro getAction item actionName>
    <#t>
    <#if item.getPSDEUIActionGroup2()?? && item.getPSDEUIActionGroup2()??><#if item.getPSDEUIActionGroup2().getPSUIActionGroupDetails?? && item.getPSDEUIActionGroup2().getPSUIActionGroupDetails()??><#list item.getPSDEUIActionGroup2().getPSUIActionGroupDetails() as action><#if action.getPSUIAction().getCodeName()== actionName>isShowCaption:${action.isShowCaption()?c},isShowIcon:${action.isShowIcon()?c}</#if></#list></#if></#if><#t>
    </#macro>

    /**
     * 界面行为模型
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public ActionModel:any ={
    <#if ctrl.getPSUIActions()??>
    <#list ctrl.getPSUIActions() as item>
        ${item.getUIActionTag()}: { name: '${item.getUIActionTag()}',disabled: false, visabled: true,noprivdisplaymode:<#if item.getNoPrivDisplayMode(view)??>${item.getNoPrivDisplayMode(view)}</#if>,dataaccaction: '<#if item.getDataAccessAction()??>${item.getDataAccessAction()}</#if>', target: '${item.getActionTarget()}',icon:'<#if item.getPSSysImage?? && item.getPSSysImage()??><@setIcon item /></#if>',<@getAction ctrl  item.getCodeName() />}<#if item_has_next>,</#if>
    </#list>
    </#if>  
    };

    

    /**
     * 获取界面行为权限状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getActionState(data:any){
        //let targetData:any = this.transformData(data);
        let tempActionModel:any = JSON.parse(JSON.stringify(this.ActionModel));
        this.$viewTool.calcActionItemAuthState(data,tempActionModel,this.deUIService);
        return tempActionModel;
    }

    /**
    * 判断列表项左滑右滑禁用状态
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}Base
    */
    public setSlidingDisabled(item:any){
        item.sliding_disabled = true;
        Object.keys(this.ActionModel).forEach((key,index) => {
           if(item[key].visabled && item.sliding_disabled ){
             item.sliding_disabled = false;
           }
        })

    }

    /**
     * 长按定时器
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public timeOutEvent :number = 0;

    /**
     * 开始长按
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public gotouchstart(){
        let _this = this;
        clearTimeout(this.timeOutEvent); //清除定时器
        this.timeOutEvent = 0;
        this.timeOutEvent = setTimeout(() => {
            if(_this.timeOutEvent > 0){
                this.onCheackChange();
            }
            console.log(this.timeOutEvent);
            this.timeOutEvent = 0
        }, 2000); //这里设置定时
    }

    /**
     * touchmove
     *  如果手指有移动，则取消所有事件，此时说明用户只是要移动而不是长按
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public gotouchmove() {
        clearTimeout(this.timeOutEvent); //清除定时器
        this.timeOutEvent = 0;
    }

    /**
     * touchend
     * 结束长按
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public gotouchend() {
        this.timeOutEvent = 0;
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>